[32bit] prefix decimal

0 ,

code VAR ( - a )                ( g: Runtime for CREATE and VARIABLE )
        pushd
        pop t
        ret end-code

code VAL ( - n )                ( g: Runtime for VALUE and CONSTANT )
        sub sp 4 #
        mov 0 [sp] t
        pop t
        mov t 0 [t]
        ret end-code

code SP@ ( - a )                ( g: Fetch the current parameter stack pointer )
        sub sp 4 #
        mov 0 [sp] t
        mov t sp
        ret end-code

code RP@ ( - a )                ( g: Fetch the current return stack pointer )
        sub sp 4 #
        mov 0 [sp] t
        mov t rp
        add t 4 #
        ret end-code

code SP! ( a - )                ( g: Set the current parameter stack pointer )
        mov sp t
        mov t 0 [sp]
        add sp 4 #
        ret end-code

code RP! ( a - )                ( g: Set the current return stack pointer )
        pop w
        mov rp t
        mov t 0 [sp]
        add sp 4 #
        jmp w end-code

code EXECUTE ( xt - )
        mov w t
        lodsd
        jmp w end-code

icode NOOP ( - )
        ret end-code

\ ------------- Data Stack -----------------------------------------------------

icode DUP ( n - n n )
        sub sp 4 #
        mov 0 [sp] t
        ret end-code

code ?DUP ( x - x | x x )
        or t t
        0<>, <if>
           sub sp 4 #
           mov 0 [sp] t
        <then> ret end-code

code 2DUP ( n n2 - n n2 n n2 )
        sub sp 8 #
        mov 4 [sp] t
        mov w 8 [sp]
        mov 0 [sp] w
        ret end-code

icode DROP ( n - )
        lodsd
        ret end-code

icode 2DROP ( n n2 - )
        lodsd
        lodsd
        ret end-code

code OVER ( n n1 - n n1 n )
        sub sp 4 #
        mov 0 [sp] t
        mov t 4 [sp]
        ret end-code

code 2OVER
        sub sp 8 #
        mov 4 [sp] t
        mov w 16 [sp]
        mov 0 [sp] w
        mov t 12 [sp]
        ret end-code

icode NIP ( n n2 - n2 )
        add sp 4 #
        ret end-code

icode SWAP ( n n1 - n1 n )
        mov w t
        mov t 0 [sp]
        mov 0 [sp] w
        ret end-code

code 2SWAP ( n n2 n3 n4 - n3 n4 n n2 )
        xchg t 4 [sp]
        mov w 0 [sp]
        xchg w 8 [sp]
        mov 0 [sp] w
        ret end-code

code TUCK ( n n2 - n2 n n2 )
        mov w 0 [sp]
        sub sp 4 #
        mov 4 [sp] t
        mov 0 [sp] w
        ret end-code

code ROT ( n n1 n2 - n2 n3 n )
        mov w 4 [sp]
        mov x 0 [sp]
        mov 0 [sp] t
        mov 4 [sp] x
        mov t w
        ret end-code

icode PICK
        mov t 0 [sp] [t*4]
        ret end-code

\ ------------- Return Stack ---------------------------------------------------

code PUSH ( n - )
        pop w
        push t
        mov t 0 [sp]
        add sp 4 #
        jmp w end-code

code POP ( - n )
        sub sp 4 #
        mov 0 [sp] t
        pop w
        pop t
        jmp w end-code

code R@ ( - n )
        sub sp 4 #
        mov 0 [sp] t
        mov t 4 [rp]
        ret end-code

code 2PUSH ( n n2 - ) ( r: - n n2 )
        pop w
        push 0 [sp]
        push t
        mov t 4 [sp]
        add sp 8 #
        jmp w end-code

code 2POP ( - n n2 ) ( r: n n2 - )
        pop w
        sub sp 8 #
        mov 4 [sp] t
        pop t
        pop 0 [sp]
        jmp w end-code

code @R+ ( - n )
        sub sp 4 #
        mov 0 [sp] t
        mov w 4 [rp]
        mov t 0 [w]
        add w 4 #
        mov 4 [rp] w
        ret end-code

code !R+ ( n - )
        mov w 4 [rp]
        mov 0 [w] t
        add w 4 #
        mov 4 [rp] w
        mov t 0 [sp]
        add sp 4 #
        ret end-code

code R+ ( n - )
   add 4 [rp] t
   lodsd
   ret end-code
   
\ ------------- Address Register -----------------------------------------------

hex

icode A! ( n - )
        mov ap t
        lodsd
        ret end-code

icode A@ ( - n )
        sub sp 4 #
        mov 0 [sp] t
        mov t ap
        ret end-code

icode !A ( n - )
        mov 0 [ap] t
        lodsd
        ret end-code

icode @A ( - n )
        sub sp 4 #
        mov 0 [sp] t
        mov t 0 [ap]
        ret end-code

icode A+ ( n - )
        add ap t
        lodsd
        ret end-code

code @A+ ( - n )
        sub sp 4 #
        mov 0 [sp] t
        mov t 0 [ap]
        add ap 4 #
        ret end-code

icode !A+ ( n - )
        stosd
        lodsd
        ret end-code

code C@A ( - n )
        sub sp 4 #
        mov 0 [sp] t
        xor t t
        mov t 0 [ap]
        ret end-code

icode C!A ( n - )
        mov 0 [ap] al
        lodsd
        ret end-code

code C@A+ ( - n )
        sub sp 4 #
        mov 0 [sp] t
        xor t t
        mov t 0 [ap]
        inc ap
        ret end-code

icode C!A+ ( n - )
        stosb
        lodsd
        ret end-code

decimal

\ ------------- Conditionals ---------------------------------------------------

code = ( n n2 - f )
        cmp t 0 [sp]
        mov t 0 #
        =, <if>
           dec t
        <then>
        add sp 4 #
        ret end-code

code <> ( n n2 - f )
        cmp t 0 [sp]
        mov t 0 #
        <>, <if>
           dec t
        <then>
        add sp 4 #
        ret end-code

code 0= ( n - f )
        neg t
        sbb t t
        not t
        ret end-code

code 0<> ( n - f )
        neg t
        sbb t t
        ret end-code

code < ( n n2 - f )
        cmp t 0 [sp]
        mov t 0 #
        >=, <if>
           dec t
        <then>
        add sp 4 #
        ret end-code

code > ( n n2 - f )
        cmp t 0 [sp]
        mov t 0 #
        <=, <if>
           dec t
        <then>
        add sp 4 #
        ret end-code

code U< ( u1 u2 - f )
        cmp 0 [sp] t
        sbb t t
        add sp 4 #
        ret end-code

code U> ( u1 u2 - f )
        cmp t 0 [sp]
        sbb t t
        add sp 4 #
        ret end-code

code 0> ( n - f )
        cmp t 0 #
        mov t 0 #
        >=, <if>
           dec t
        <then> ret end-code

code 0< ( n - f )
        cmp t 0 #
        mov t 0 #
        <=, <if>
           dec t
        <then> ret end-code

code TRUE ( - -1 )
        sub sp 4 #
        mov 0 [sp] t
        mov t -1 #
        ret end-code

code FALSE ( - 0 )
        sub sp 4 #
        mov 0 [sp] t
        xor t t
        ret end-code

\ ------------- Memory ---------------------------------------------------------

hex

icode CHARS ( n - chars )
        ret end-code

icode CHAR+ ( n - n' )
        inc t
        ret end-code

icode CHAR- ( n - n' )
        dec t
        ret end-code

icode CELLS ( n - n' )
        shl t 2 #
        ret end-code

icode CELL+ ( n - n' )
        add t 4 #
        ret end-code

icode CELL- ( n - n' )
        sub t 4 #
        ret end-code

icode @ ( a - n )
        mov t 0 [t]
        ret end-code

icode @+ ( a - n a+4 )
   sub sp 4 #
   mov w 0 [t]
   add t 4 #
   mov 0 [sp] w
   ret end-code

icode !+ ( n a - a+4 )
   mov w 0 [sp]
   add sp 4 #
   mov 0 [t] w
   add t 4 #
   ret end-code

icode ! ( n a - )
        mov w 0 [sp]
        mov 0 [t] w
        lodsd
        lodsd
        ret end-code

icode C@ ( ca - n )
        xchg t w
        xor t t
        mov al 0 [w]
        ret end-code

icode C! ( n a - )
        mov w 0 [sp]
        mov 0 [t] dl
        lodsd
        lodsd
        ret end-code

icode W@ ( a - n )
        mov ax 0 [t]
        and t ffff #
        ret end-code

icode W! ( n a - )
        mov w 0 [sp]
        mov 0 [t] dx
        lodsd
        lodsd
        ret end-code

icode +! ( n a - )
        mov w 0 [sp]
        add 0 [t] w
        lodsd
        lodsd
        ret end-code

\ ------------- Arithmatic -----------------------------------------------------

decimal

icode + ( n n2 - n3 )
        add t 0 [sp]
        add sp 4 #
        ret end-code

icode - ( n n2 - n3 )
        sub 0 [sp] t
        lodsd
        ret end-code

icode 1+ ( n - n' )
        inc t
        ret end-code

icode 1- ( n - n' )
        dec t
        ret end-code

icode u+ ( n n2 n3 - n4 )
   add 4 [sp] t
   lodsd
   ret end-code

icode * ( n n2 - n3 )
        mov x t
        lodsd
        mul x
        ret end-code

icode / ( n n2 - n3 )
        mov x t
        lodsd
        cdq
        idiv x
        ret end-code

code /MOD ( n n2 - n3 n4 )
        mov x t
        mov t 0 [sp]
        cdq
        idiv x
        mov 0 [sp] w
        ret end-code

icode 2* ( n - n' )
        shl t 1 #
        ret end-code

icode 2/ ( n - n' )
        sar t 1 #
        ret end-code

code MOD ( n n2 - n3 )
        mov x t
        lodsd
        cdq
        idiv x
        mov t w
        ret end-code

code */MOD ( n1 n2 n3 -- n4 n5 )
        mov x t
        mov y 0 [sp]
        mov t 4 [sp]
        imul y
        add sp 4 #
        idiv x
        mov 0 [sp] w
        ret end-code

code */ ( n1 n2 n3 -- n4 )
        mov x t
        mov y 0 [sp]
        mov t 4 [sp]
        imul y
        add sp 8 #
        idiv x
        ret end-code

code M* ( n1 n2 -- d )
        mov x t
        mov t 0 [sp]
        imul x
        mov 0 [sp] t
        mov t w
        ret end-code

code UM* ( u1 u2 - ud )
        mov x t
        mov t 0 [sp]
        mul x
        mov 0 [sp] t
        mov t w
        ret end-code

code UM/MOD ( ud u1 - u2 u3 )
        mov w 0 [sp]
        mov x t
        mov t 4 [sp]
        add sp 4 #
        div x
        mov 0 [sp] w
        ret end-code
        
icode AND ( n n2 - n3 )
        and t 0 [sp]
        add sp 4 #
        ret end-code

icode OR ( n n2 - n3 )
        or t 0 [sp]
        add sp 4 #
        ret end-code

icode XOR ( n n2 - n3 )
        xor t 0 [sp]
        add sp 4 #
        ret end-code

icode INV ( n - n2 )
        not t
        ret end-code

icode NEG ( n - n2 )
        neg t
        ret end-code

code ABS ( n - |n| )
        or t t
        0<, <if>
           neg t
        <then>
        ret end-code

icode SHR ( n - )
        mov x t
        lodsd
        shr t cl
        ret end-code

icode SHL ( n - )
        mov x t
        lodsd
        shl t cl
        ret end-code

code MAX ( n n2 - max )
        mov w 0 [sp]
        cmp t w
        <=, <if>
           mov t w
        <then>
        add sp 4 #
        ret end-code

code MIN ( n n2 - max )
        mov w 0 [sp]
        cmp t w
        >=, <if>
           mov t w
        <then>
        add sp 4 #
        ret end-code

code WITHIN ( n n2 n3 - f )
        mov w 0 [sp]
        mov x 4 [sp]
        add sp 8 #
        sub t w
        sub x w
        sub x t
        sbb t t
        ret end-code

code DABS ( d - ud )
        cmp t t
        0<, <if>
           neg t
           neg 0 [sp]
           sbb t 0 #
        <then> ret end-code

code S>D ( u - ud )
        sub sp 4 #
        mov 0 [sp] t
        shl t 1 #
        sbb t t
        ret end-code

code D>S ( ud - u )
        mov t 0 [sp]
        add sp 4 #
        ret end-code

\ ------------- Strings --------------------------------------------------------

decimal

code (S') ( - ca u )
        sub sp 8 #
        mov 4 [sp] t
        pop w
        mov x w
        inc x
        mov 0 [sp] x
        xor t t
        mov al 0 [w]
        mov x t
        inc x
        add x w
        jmp x end-code hide

code (C') ( - ca )
        sub sp 4 #
        mov 0 [sp] t
        xor x x
        pop t
        mov cl 0 [t]
        inc x
        add x t
        jmp x end-code hide

code CMOVE ( ca ca2 u2 - )
        cmp t 0 #
        <>, <if>
           mov w 0 [sp]
           mov x 4 [sp]
           <begin>
              mov bl 0 [x]
              mov 0 [w] bl
              inc x
              inc w
              dec t
              0=,
           <until>
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code CMOVE> ( ca ca2 u2 - )
        cmp t 0 #
        <>, <if>
           mov w 0 [sp]
           mov x 4 [sp]
           add w t
           add x t
           <begin>
              mov bl -1 [x]
              mov -1 [w] bl
              dec x
              dec w
              dec t
              0=,
           <until>
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code MOVE ( a a2 u2 - )
        cmp t 0 #
        <>, <if>
           mov w 0 [sp]
           mov x 4 [sp]
           <begin>
              mov y 0 [x]
              add x 4 #
              mov 0 [w] y
              add w 4 #
              dec t
              0=,
           <until>
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code MSWAP ( a a2 u2 - )
        cmp t 0 #
        <>, <if>
           push ap
           mov w 0 [sp]
           mov ap t
           mov x 4 [sp]
           <begin>
              mov y 0 [x]
              mov t 0 [w]
              mov 0 [x] t
              mov 0 [w] y
              add x 4 #
              add w 4 #
              dec ap
              0=,
           <until>
           pop ap
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code MAND ( a a2 u2 - )
        cmp t 0 #
        <>, <if>
           mov w 0 [sp]
           mov x 4 [sp]
           <begin>
              mov y 0 [x]
              add x 4 #
              and 0 [w] y
              add w 4 #
              dec t
              0=,
           <until>
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code MOR ( a a2 u2 - )
        cmp t 0 #
        <>, <if>
           mov w 0 [sp]
           mov x 4 [sp]
           <begin>
              mov y 0 [x]
              add x 4 #
              or 0 [w] y
              add w 4 #
              dec t
              0=,
           <until>
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code MXOR ( a a2 u2 - )
        cmp t 0 #
        <>, <if>
           mov w 0 [sp]
           mov x 4 [sp]
           <begin>
              mov y 0 [x]
              add x 4 #
              xor 0 [w] y
              add w 4 #
              dec t
              0=,
           <until>
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code SCAN ( ca u char -- ca' u' )
        push ap
        mov x 0 [sp]
        or x x
        0<>, <if>
           mov ap 4 [sp]
           repne scasb
           0=, <if>
              inc x
              dec ap
           <then>
           mov 4 [sp] ap
        <then>
        mov t x
        add sp 4 #
        pop ap
        ret end-code

code SKIP ( ca u char -- ca' u' )
        push ap
        mov x 0 [sp]
        or x x
        0<>, <if>
           mov ap 4 [sp]
           repe scasb
           0<>, <if>
              inc x
              dec ap
           <then>
           mov 4 [sp] ap
        <then>
        mov t x
        add sp 4 #
        pop ap
        ret end-code

code COMPARE ( ca u ca2 u2 -- n )
        cmp t 4 [sp]
        =, <if>
           mov w sp
           mov x t
           push ap
           mov ap 0 [w]
           mov sp 8 [w]
           repe cmpsb
           0<>, <if>
              0<, <if>
                 mov t -1 #
              <else>
                 mov t 1 #
              <then>
           <else>
              mov t 0 #
           <then>
           mov sp w
           pop ap
        <else>
           mov t -1 #
        <then>
        add sp 12 #
        ret end-code

code /STRING ( ca u n - )
        mov w 0 [sp]
        mov x 4 [sp]
        add x t
        sub w t
        mov 4 [sp] x
        mov t w
        add sp 4 #
        ret end-code

code COUNT ( ca - ca+1 u )
        xor w w
        mov dl 0 [t]
        inc t
        sub sp 4 #
        mov 0 [sp] t
        mov t w
        ret end-code

code FILL ( ca u c - )
        mov x 0 [sp]
        cmp x 0 #
        <>, <if>
           mov w 4 [sp]
           <begin>
              mov 0 [w] al
              inc w
              dec x
              0=,
           <until>
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code FLOOD ( a u n - )
        mov x 0 [sp]
        cmp x 0 #
        <>, <if>
           mov w 4 [sp]
           <begin>
              mov 0 [w] t
              add w 4 #
              dec x
              0=,
           <until>
        <then>
        mov t 8 [sp]
        add sp 12 #
        ret end-code

code DIGIT ( c base - n f )
        mov w 0 [sp]
        sub w 48 #
        jb <if>
           cmp w 9 #
           jbe L1
           sub w 7 #
           cmp w 10 #
           jb <if>
L1:           cmp w t
              jae <if>
                 mov 0 [sp] w
                 mov t -1 #
                 ret
              <then>
           <then>
        <then>
        xor t t
        ret end-code

\ ------------- Loops ----------------------------------------------------------

decimal

code (DO) ( n n2 - ) ( r: - leave index count )
        pop w
        mov x w
        add x 0 [w]
        add w 4 #
        push x
        mov x 0 [sp]
        push x
        sub x t
        neg x
        push x
        mov t 4 [sp]
        add sp 8 #
        jmp w end-code hide

code (?DO) ( n n2 - ) ( r: - loop-sys | )
        pop w
        mov x w
        add x 0 [w]
        cmp t 0 [sp]
        <>, <if>
           add w 4 #
           push x
           mov x 0 [sp]
           push x
           sub x t
           neg x
           push x
           mov t 4 [sp]
           add sp 8 #
           jmp w
        <then>
        mov t 4 [sp]
        add sp 8 #
        jmp x end-code hide

code (LOOP) ( - ) ( r: loop-sys - | loop-sys2 )
        pop w
        inc 0 [rp]
        0>, <if>
           add w 4 #
           add rp 12 #
           jmp w
        <then>
        add w 0 [w]
        jmp w end-code hide

code (+LOOP) ( n - ) ( r: loop-sys - | loop-sys2 )
        pop w
        add 0 [rp] t
        0>, <if>
           add w 4 #
           add rp 12 #
           mov t 0 [sp]
           add sp 4 #
           jmp w
        <then>
        add w 0 [w]
        mov t 0 [sp]
        add sp 4 #
        jmp w end-code hide

code I ( - n ) ( r:  loop-sys - loop-sys )
        sub sp 4 #
        mov 0 [sp] t
        mov t 4 [rp]
        add t 8 [rp]
        ret end-code

code J ( - n ) ( r: loop-sys1 loop-sys2 - loop-sys1 loop-sys2 )
        sub sp 4 #
        mov 0 [sp] t
        mov t 16 [rp]
        mov t 20 [rp]
        ret end-code

code UNLOOP ( - ) ( r: loop-sys - )
        mov w 0 [rp]
        add rp 16 #
        jmp w end-code

code LEAVE ( - ) ( r: loop-sys - )
        mov w 12 [rp]
        add rp 16 #
        jmp w end-code

\ ------------- Control Structures ---------------------------------------------

decimal

code (JMP) ( - )
        pop w
        add w 0 [w]
        jmp w end-code hide

code (OF) ( n n2 - n | )
        cmp t 0 [sp]
        =, <if>
           mov t 4 [sp]
           add sp 8 #
           pop w
           add w 4 #
           jmp w
        <then>
        mov t 0 [sp]
        add sp 4 #
        pop w
        add w 0 [w]
        jmp w end-code hide

\ ------------- Tasks ----------------------------------------------------------

decimal

code self ( - a )               ( g: Active task's User Pointer or Task Context Block )
        sub sp 4 #
        mov 0 [sp] t
        mov t up
        ret end-code

( Task Context Block Layout )

00
dup constant tcb>actlink  hide cell+    \ Active Tasks Ring Link Field
dup constant tcb>nfa      hide cell+    \ Task Name Field Address
dup constant tcb>base     hide cell+    \ Numeric Radix
dup constant tcb>sp       hide 260 +    \ Parameter Stack Pointer
dup constant tcb>sp0      hide 8   +    \ Parameter Stack Base
dup constant tcb>rp       hide 260 +    \ Return Stack Pointer
dup constant tcb>rp0      hide 8   +    \ Return Stack Base
dup constant tcb>hand     hide cell+    \ Error Handler
dup constant tcb>areg     hide cell+    \ Address Register
dup constant tcb>dp       hide cell+    \ Dictionary Pointer
dup constant tcb>dp0      hide cell+    \ Dictionary Base
dup constant tcb>hp       hide cell+    \ Header Pointer
dup constant tcb>hp0      hide cell+    \ Header Base
dup constant tcb>root     hide cell+    \ Forth Wordlist
dup constant tcb>flux     hide cell+    \ Flux Wordlist
dup constant tcb>macro    hide cell+    \ Macro Wordlist
dup constant tcb>state    hide cell+    \ Compiler State
dup constant tcb>blk      hide cell+    \ Block
dup constant tcb>sblk     hide cell+    \ Superblock Address
dup constant tcb>tib      hide cell+    \ Source Buffer
dup constant tcb>#tib     hide cell+    \ Source Buffer Length
dup constant tcb>in       hide cell+    \ Source Pointer
dup constant tcb>sid      hide cell+    \ Source ID
dup constant tcb>hist     hide cell+    \ History
dup constant tcb>hld      hide 40  +    \ Hold Pointer & Number Conversion Buffer (36 bytes)
dup constant tcb>spad     hide 256 +    \ Source String Buffer (256 bytes)
dup constant tcb>current  hide cell+    \ Definitions Wordlist
dup constant tcb>search   hide cell+    \ Search Length
dup constant tcb>swb      hide 64  +    \ Search Order (64 bytes = 16 wordlists)
dup constant tcb>focus    hide cell+    \ Terminal Focus
dup constant tcb>mark     hide cell+    \ Dictionary Marker
drop

( Accessable User Variables )

tcb>base    user base
tcb>sp0     user sp0
tcb>rp0     user rp0
tcb>hand    user hand
tcb>dp      user dp
tcb>dp0     user dp0
tcb>hp      user hp
tcb>hp0     user hp0
tcb>root    user root
tcb>flux    user flux
tcb>macro   user macro
tcb>state   user state
tcb>blk     user blk
tcb>sblk    user superblock
tcb>tib     user 'tib
tcb>#tib    user #tib
tcb>in      user >in
tcb>sid     user sid
tcb>hist    user history
tcb>hld     user hld
tcb>spad    user spad
tcb>current user current
tcb>search  user searching
tcb>swb     user swb
tcb>focus   user focus
tcb>mark    user mark

defer pause

\ ------------- Dictionary -----------------------------------------------------

: depth ( - n ) sp@ sp0 swap - 2/ 2/ ;
: ..    ( - ) sp0 sp! ;
: ..r   ( - ) pop rp0 rp! push ;

hex

: HERE      ( - a ) dp @ ;
: ALLOT     ( n - ) dp +! ;
: ALIGNED   ( a - a' ) 1- 4 2dup mod - + ;
: SOURCE-ID ( - n ) sid @ ;
: NFA>CFA   ( a - a' ) dup c@ 1+ aligned + @ ;
: NFA>PFA   ( a - a' ) cell- 1- ;
: ,         ( n - ) here  ! 4 allot ;
: C,        ( c - ) here c! 1 allot ;
: EXIT      ( - ) c3 c, ;                                              immediate
: COMPILE,  ( xt - ) e8 c, here cell+ - , ;
: PAD       ( - a ) here aligned 100 + ;

\ ------------- Control Structures ---------------------------------------------

hex

: <IF>      ( - orig ) 0fadc009 , 84 c, ;                              hide
: <ELSE>    ( orig - orig2 ) e9 c, ;                                   hide
: <THEN>    ( orig - ) here over - cell- swap ! ;                      hide
: <MARK>    ( - orig ) here 4 allot ;                                  hide
: <RESOLVE> ( dest - ) here cell+ - , ;                                hide

: IF     ( - orig ) <if> <mark> ;                                      immediate
: THEN   ( orig - ) <then> ;                                           immediate
: ELSE   ( orig - orig2 ) <else> <mark> swap <then> ;                  immediate
: BEGIN  ( - dest ) here ;                                             immediate
: UNTIL  ( dest - ) <if> <resolve> ;                                   immediate
: AGAIN  ( dest - ) <else> <resolve> ;                                 immediate
: WHILE  ( dest - orig dest ) <if> <mark> swap ;                       immediate
: REPEAT ( orig dest - ) <else> <resolve> <then> ;                     immediate
: NEXT   ( dest - ) 48 c, 0f c, 85 c, <resolve> ad c, ;                immediate

: <SNAG> ( orig - ) here over - swap ! ;                               hide

: CASE    ( - cs ) false ;                                             immediate
: OF      ( - os ) postpone (of) <mark> ;                              immediate
: ENDOF   ( cs os - cs2 ) postpone (jmp) <mark> swap <snag> swap 1+ ;  immediate
: ENDCASE ( cs - ) postpone drop 0 ?do <snag> loop ;                   immediate
: DO      ( - orig dest ) postpone (do) <mark> here ;                  immediate
: ?DO     ( - orig dest ) postpone (?do) <mark> here ;                 immediate
: LOOP    ( orig dest - ) postpone (loop) here - , <snag> ;            immediate
: +LOOP   ( orig dest - ) postpone (+loop) here - , <snag> ;           immediate

\ ------------- Input Stream ---------------------------------------------------

hex

20 constant BL

: SOURCE  ( - ca u ) 'tib @ #tib @ ;
: SOURCE> ( - ca u ) source >in @ /string ;

: PARSE ( char "ccc<chapop" - ca u  )
        push source> 2dup pop scan nip dup 0<>
        if     - dup 1+
        else   - dup
        then >in +! ;

: >UC ( c - ) dup 61 7b within if bl - then ;

: >UCASE ( ca - ca )
        dup count 0
        ?do     dup i + dup c@ >uc swap c!
        loop drop ;

: WORD ( char "<chars>ccc<chapop" -- ca )
        source> 2 pick skip drop 'tib @ - dup >in ! #tib @ <>
        if     parse dup spad c! spad 1+ swap cmove
        else   drop 0 spad c!
        then spad ;

\ ------------- Numbering ------------------------------------------------------

hex

: LITERAL ( n - ) 83 c, ee c, 04 c, 89 c, 06 c,  b8 c, , ; immediate

: CHAR ( - n ) bl word 1+ c@ ;

: [CHAR] ( - ) char postpone literal ; immediate

: DECIMAL ( - ) 0a base ! ;
: HEX     ( - ) 10 base ! ;
: BINARY  ( - ) 2  base ! ;

: HOLD ( c - ) hld @ 1- dup hld ! c! ;
: SIGN ( n - ) 0< if 2d hold then ;
: #    ( ud - ud' ) base @ push 0 r@ um/mod rot rot pop um/mod rot rot dup 9 > 7 and + 30 + hold ;
: <#   ( - ) spad hld ! ;
: #S   ( ud - ud2 ) begin # 2dup or 0= until ;
: #>   ( xd - ca u ) 2drop hld @ spad over - ;

: >NUMBER ( ud ca u -- ud2 ca2 u2 )
        begin   dup
        while   over c@ base @ digit 0= if drop exit then
                push 2swap swap base @ * pop + swap 2swap 1 /string
        repeat ;

: NUMBER? ( ca -- ca 0 | x -1 )
        >ucase 0 0 2 pick count
        over c@ 2d = if 1- push 1+ pop -1 else 1 then push >number
        if      pop 2drop 2drop false
        else    2drop nip pop * true
        then ;

\ ------------- Compiler -------------------------------------------------------

hex

create VACANT-WORDLIST 5 allot hide     \ link = 1 cell, name = 1 byte

create HIDDEN 4 allot

: WORDLIST ( - wid ) here vacant-wordlist cell+ , ;
: CONTEXT ( - a ) swb searching @ 1- cells + ;
: GET-CURRENT ( - wid ) current @ ;
: SET-CURRENT ( wid - ) current ! ;
: GET-ORDER ( widn ... wid1 n - )
   swb push searching @ begin @r+ swap next pop drop searching @ ;

: SET-ORDER ( widn ... wid1 n - )
   dup 0= if searching ! exit then
   dup 0< if drop root 1 then
   dup searching ! begin tuck 1- cells swb + ! next ;

: +ORDER ( wid - ) push get-order pop swap 1+ set-order ;
: -ORDER ( - ) -1 searching +! ;

: DEFINITIONS ( - ) context @ set-current ;

: CHANGE ( - ) get-order push swap dup set-current pop set-order ;

: ONLY ( - ) -1 set-order ;
: ALSO ( - ) get-order over swap 1+ set-order ;
: PREVIOUS ( - ) -1 searching +! ;
: FORTH-WORDLIST ( - ) root ;
: FORTH ( - ) get-order nip root swap set-order ;

: SEARCH-WORDLIST ( ca u wid - 0 | xt 1 | xt -1 )
   a@ push @ a!
   begin 2dup a@ count compare 0=
      if a@ nfa>pfa c@ 40 and 0=                        \ smudging = bit 6 set
         if drop drop a@ nfa>cfa a@ nfa>pfa
            c@ dup here c! 80 and 0= 1 or pop a! exit   \ precedence-byte HERE c!, immediacy = bit 7 set
      then then a@ cell- @ dup
   while a!
   repeat nip nip pop a! ;

: FIND ( ca - ca 0 | xt 1 | xt -1 )
   >ucase searching @
   begin push dup count r@ 1- cells swb + @ search-wordlist
      dup if rot drop pop drop exit then drop pop
   next false ;

: ' ( - xt ) bl word find drop ;

defer ACCEPT
defer QUIT

: ABORT  ( - ) .. 0 hand ! quit ;

: CATCH  ( xt - f ) sp@ push hand @ push rp@ hand ! execute pop hand ! pop drop false ;

: THROW  ( n - | n )
        ?dup
        if      hand @ 0=
                if      abort
                else    hand @ rp! pop hand ! pop swap push sp! drop pop
                then
        then ;

: INTERPRET ( - )
   begin bl word dup c@
   while find dup
      if 1+ state @ 0= or
         if execute depth 0<
            if 1 throw
            then
         else here c@ 0f and                    \ precedence says inlinable code?
            if here dup c@ dup allot cmove      \ compile inline
            else compile,                       \ compile a call
            then
         then
      else drop number?
         if state @
            if postpone literal
            then
         else 2 throw
         then
      then pause
   repeat drop ;

: EVALUATE ( ca u - )
        #tib @ push 'tib @ push >in @ push sid @ push -1 sid ! 0 >in ! #tib ! 'tib !
        0 blk ! ['] interpret catch pop sid ! pop >in ! pop 'tib ! pop #tib ! throw ;

400 constant ABLOCK hide

: PREPARE ( ca u - ) swap a! begin c@a+ bl < if bl a@ 1- c! then next ; hide

: BLOCK ( u - a ) ablock * superblock @ + ;

: LOAD ( u - )
        blk @ push #tib @ push 'tib @ push >in @ push
        dup blk ! ablock #tib ! 0 >in ! block 'tib ! ['] interpret catch
        pop >in ! pop 'tib ! pop #tib ! pop blk ! throw ;

: +LOAD ( u - ) blk @ + load ;

: SLOAD ( u a - )
   superblock @ push superblock ! ['] load catch pop superblock ! throw ;

defer FLOAD

: SFLOAD ( u a - )
   superblock @ push superblock ! ['] fload catch pop superblock ! throw ;

: THRU ( u u2 - ) 1+ swap ?do i load loop ;
: +THRU ( u u2 - ) blk @ tuck + push + pop thru ;
: STHRU ( u u2 a - ) superblock @ push superblock ! ['] thru catch pop superblock ! throw ;

: NOPS      ( n - ) dup if begin 90 c, next exit then drop ;                     hide
: ALIGN     ( - ) here dup aligned swap - nops ;
: NAME,     ( ca - ) >ucase dup c@ 1+ here swap dup allot cmove align ;          hide
: ALIGN-1   ( - ) here dup aligned swap - dup if 1- nops else drop 3 nops then ; hide
: DSWAP     ( - ) dp @ hp @ dp ! hp ! dp0 @ hp0 @ dp0 ! hp0 ! ;                  hide
: NEWCFA    ( a - ) get-current @ dup c@ 1+ aligned + ! ;                        hide

: HEADER,   ( - ) here dswap align-1 0 c, get-current @ , here get-current ! bl word name, , dswap ; hide
: CREATE    ( - ) align-1 header, postpone var ;
: >BODY     ( a - a' ) 1+ cell+ ;
: VARIABLE  ( - ) create 0 , ;
: VALUE     ( n - ) header, postpone val , ;
: CONSTANT  ( n - ) value ;
: (DOES>)   ( - ) get-current @ nfa>cfa 1+ pop over cell+ - swap ! ;   hide
: DOES>     ( - ) postpone (does>) postpone pop ; immediate
: DEFER     ( - ) header, postpone noop e9 here 5 - c! ;
: IMMEDIATE ( - ) get-current @ nfa>pfa dup c@ 80 or swap c! ;
: SMUDGE    ( - ) get-current @ nfa>pfa dup c@ 40 or swap c! ;         hide
: SHINE     ( - ) get-current @ nfa>pfa dup c@ bf and swap c! ;        hide

: POSTPONE ( - )
   bl word find dup
   if 0<
      if postpone literal postpone compile, exit
      then compile, exit
   then drop ;                                                         immediate

: [       ( - ) false state ! ;                                        immediate
: ]       ( - ) true state ! ;
: :       ( - ) header, smudge ] ;
: ;       ( - ) postpone exit postpone [ shine ;                       immediate
: [']     ( - ) ' postpone literal ;                                   immediate
: RECURSE ( - ) get-current @ nfa>cfa compile, ;                       immediate
: :NONAME ( - xt ) here ] ;                                            immediate

: REFILL ( - flag ) blk @
        if      1 blk +! blk @ block 'tib ! ablock #tib !
        else    'tib @ 100 accept #tib !
        then    0 >in ! true ;

\ ------------------------------------------------------------------------------

: TO ( n - )
        ' 1+ cell+ state @
        if      postpone literal postpone !
        else    !
        then ;                                                         immediate

: +TO ( n - )
        ' 1+ cell+ state @
        if      postpone literal postpone +!
        else    +!
        then ;                                                         immediate

: (is) ( cfa - )
   r@ @ 1+ tuck cell+ - swap ! 4 r+ ; hide

: IS ( cfa - )
        ' state @
        if      postpone (is) ,
        else    1+ tuck cell+ - swap !
        then ;                                                         immediate

\ ------------- Video ----------------------------------------------------------

hex

defer AT-XY
defer GET-XY
defer EMIT
defer TYPE
defer >FG
defer >BG
defer PAGE
defer CR

defer WORDS
defer DUMP

0000 value BLACK
ffff value WHITE
001f value BLUE
07e0 value GREEN
f800 value RED
07ff value CYAN
f81f value MAGENTA
c618 value GRAY
ffe0 value YELLOW

: SPACE ( - ) bl emit ;

: SPACES ( n - ) dup if begin space next exit then drop ;

\ ------------- Strings --------------------------------------------------------

hex

: s' ( - ca state )
        22 word state @
        if      postpone (s')
        then    dup c@ 1+ here dup push swap dup allot cmove pop state @ ; hide

: s" ( - ) s' if drop else count then ; immediate

: ." ( - ) s' if drop postpone type else count type then ; immediate

: c" ( "ccc<quote>" - )
        22 word state @
        if      postpone (c')
        then    dup c@ 1+ here dup
        push over allot swap cmove pop state @ if drop then ; immediate

: . ( n - ) <# dup abs 0 #s rot sign #> type space ;
: u. ( n - ) 0 tuck dabs <# #s rot sign #> type space ;


: ABORT" ( f - ) postpone 0<> postpone if postpone ." postpone abort postpone then ; immediate

\ ------------- Stuff ----------------------------------------------------------

decimal

defer NEGATE ' neg   is negate
defer LSHIFT ' shl   is lshift
defer RSHIFT ' shr   is rshift
defer 2R>    ' 2pop  is 2r>
defer 2>R    ' 2push is 2>r
defer R>     ' pop   is r>
defer >R     ' push  is >r

: ON ( a - ) true swap ! ;
: OFF ( a - ) false swap ! ;

: (  ( - ) 41 word drop ; immediate
: .( ( - ) 41 parse type ;
: \  ( - ) blk @ if >in @ dup 64 mod neg 64 + + else #tib @ then >in ! ; immediate

\ ------------- I/O ------------------------------------------------------------

code PC@ ( p - n )
        mov w t
        xor t t
        in al dx
        ret end-code

code PC! ( n p - )
        mov w t
        lodsd
        out dx al
        lodsd
        ret end-code

code PW@ ( p - n )
        mov w t
        xor t t
        in ax dx
        ret end-code

code PW! ( n p - )
        mov w t
        lodsd
        out dx ax
        lodsd
        ret end-code

code P@ ( p - n )
        mov w t
        in eax dx
        ret end-code

code P! ( n p - )
        mov w t
        lodsd
        out dx eax
        lodsd
        ret end-code

\ ------------- Vocabularies ---------------------------------------------------

: .list ( wid - )
   case
      root  of ." FORTH"  endof
      flux  of ." FLUX"   endof
      macro of ." MACRO"  endof
      dup [char] [ emit s>d <# #s #> type [char] ] emit
   endcase space ; hide

: order  ( - )
        cr ." Context: " get-order begin swap .list next
        cr ." Current: " get-current .list ;

\ ------------- Tools ----------------------------------------------------------

hex

: place  ( ca u ca2 - ) 2dup c! 1+ swap cmove ;
: .r     ( n n2 - ) >r <# dup abs 0 #s rot sign #> dup r@ 1+ < if r@ over - spaces then type r> drop ;
: u.r    ( n n2 - ) >r 0 tuck dabs <# #s rot sign #> dup r@ 1+ < if r@ over - spaces then type r> drop ;
: .l     ( n n2 - ) >r <# dup abs 0 #s rot sign #> r@ min tuck type neg r> + spaces ;

: -trailing ( ca u - ca u2 )
        dup 1+ 1
        ?do     2dup + i - c@ bl <>
                if      1+ i - unloop exit
                then
        loop drop 0 ;

: -leading ( ca u - ca' u' )
        tuck
        0 ?do   dup c@ 20 =
                if      1+
                else    swap i - unloop exit
                then
        loop    nip 0 ;

: blank ( ca u - ) dup if bl fill exit then 2drop ;
: erase ( a u - ) dup if 0 flood exit then 2drop ;

: append ( ca u ca2 - ) 2dup 2>r dup c@ + 1+ swap cmove 2r> swap over c@ + swap c! ;

: .s ( - )
        depth dup 0=
        if      drop ." Stack Empty"
        else    sp0 cell- swap dup
                ." (" s>d <# #s #> type ." ) " 0
                ?do dup @ . cell- loop drop ." <-tos"
        then ;
        
: .base ( - ) base @
        dup 0a = if ." DEC" then
        dup 10 = if ." HEX" then
        dup 02 = if ." BIN" then drop ; hide

: .info ( - ) get-xy 2push 0 24 at-xy .base space .s get-xy drop 5c swap - spaces 2pop at-xy ; hide

: .amiss ( n - n )
        cr red >fg ." Amiss " gray >fg spad count type dup push
        case  1 of ."  Stack Underflow" endof
              2 of ."  Undefined" endof
        endcase .. .info pop ; hide

: .ok ( - ) red >fg ."  ok" gray >fg .info cr ;

: xt:       ( - ) ' , ;
\ : via       ( a n - ) cells + @ execute ;

\ ------------- Memory Managment -----------------------------------------------

hex

variable memory0 200000 memory0 ! hide
variable memory1 2000000 memory1 ! hide

: allocate ( u - a ior )
   a@ >r aligned memory0 @ a!
   begin @a
   while a@ over 8 + @a+ @a+ a@ + - 1+ <
      if dup a! @a+ >r @a+ a@ + dup a! swap ! r> !a+ !a+ a@ false r> a! exit then @ a!
   repeat dup 8 + @a+ drop @a+ a@ + + memory1 @ <
   if a@ 8 - a! a@ >r @a+ @a+ a@ + dup a! r> ! !a+ !a+ a@ false r> a! exit
   then drop a@ true r> a! ;

: free ( a - ior )
   a@ >r 8 - memory0 @ dup >r a!
   begin dup a@ =
      if drop @a r> ! false r> a! exit
      then @a dup
   while r> drop a@ >r a!
   repeat drop drop r> drop true r> a! ;

: resize ( a u - a2 ior )
   a@ >r aligned memory0 @ a!
   begin over a@ 8 + =
      if dup @a+ dup 0=                            \ last entry?
         if drop memory1 @                         \ last gap stretch to end
         then a@ 4 + - 1+ <                        \ fit in existing's gap?
         if !a+ drop a@ false r> a! exit           \ adjust existing
         then over swap allocate                   \ allocate new
         if drop drop true r> a! exit
         then tuck @a+ cmove swap free r> a! exit  \ transfer data and free old
      then @a dup
   while a!
   repeat drop drop true r> a! ;

: blocks ( n - a ) ablock * allocate throw ;

: .mem ( - )
   cyan >fg cr ." Link Field    Length   Address"
   base @ hex gray >fg a@ >r memory0 @ a!
   begin cr @a+ dup space 9 .r @a+ space 9 .r a@ space 9 .r dup
   while a!
   repeat drop base ! r> a! ;

\ ------------ Task Zero -------------------------------------------------------

hex

: (QUIT) ( - )
   ..r 0 sid ! postpone [ cr
   begin refill
      if space ['] interpret catch ?dup
         if .amiss ABORT
      then then .ok
   again ; hide

' (quit) is quit

create consoletib 100 allot hide

create zfocus 0 , 0 , hide

create CONSOLE
        here ,                  \ active link field
        latest @ ,              \ nfa
        0a ,                    \ base
        104 allot               \ sp
        8 allot                 \ sp0
        104 allot               \ rp
        8 allot                 \ rp0
        0 ,                     \ exception frame pointer
        0 ,                     \ a register
        0 ,                     \ dictionary point
        0 ,                     \ dictionary base
        0 ,                     \ header point
        0 ,                     \ header base
        0 ,                     \ Forth Wordlist
        0 ,                     \ Flux Wordlist
        0 ,                     \ Macro Wordlist
        0 ,                     \ state
        0 ,                     \ blk
        0 ,                     \ superblock
        consoletib ,            \ 'tib
        0 ,                     \ #tib
        0 ,                     \ >in
        0 ,                     \ source-id
        0 ,                     \ history
        0 ,                     \ Hold Pointer
        24 allot                \ Number Buffer 36
        100 allot               \ System Pad 256
        console tcb>root  + ,   \ Current
        2 ,                     \ Searching
        hidden ,                \ Context
        console tcb>root  + ,
        38 allot
        zfocus ,                \ focus
        0 ,

\ ------------- Multitasking ---------------------------------------------------

hex

code switch ( - )
        pushd
        mov tcb>sp [up] sp
        mov tcb>rp [up] rp
        mov tcb>areg [up] ap
        mov up 0 [up]
        mov sp tcb>sp [up]
        mov rp tcb>rp [up]
        mov ap tcb>areg [up]
        popd
        ret end-code      hide

: single ( - ) ['] noop is pause ;
: multi  ( - ) ['] switch is pause ;

variable last-woken       hide

: his   ( up a - a' ) self - + ;

: tcb ( - )
   0 ,                     \ active link field
   get-current @ ,         \ nfa
   0a ,                    \ base
   here 104 + , 100 allot  \ sp
   8 allot                 \ sp0
   here 104 + , 100 allot  \ rp
   8 allot                 \ rp0
   0 ,                     \ exception frame pointer
   0 ,                     \ a register
   0 ,                     \ dictionary point
   0 ,                     \ dictionary base
   0 ,                     \ header point
   0 ,                     \ header base
   root @ ,                \ forth-wordlist
   flux @ ,                \ flux-wordlist
   macro @ ,               \ macro-wordlist
   0 ,                     \ state               state
   0 ,                     \ blk
   superblock @ ,          \ superblock
   0 ,                     \ 'tib                dropdup
   0 ,                     \ #tib                nipdup
   0 ,                     \ >in                 p
   0 ,                     \ source-id           cpuflag
   0 ,                     \ history             history
   0 ,                     \ Hold Pointer
   24 allot                \ Number Buffer 36
   100 allot               \ System Pad 256
   root ,                  \ Current
   1 ,                     \ Searching
   root ,                  \ Context
   3c allot
   focus @ ,               \ Focus
   0 , ; hide              \ Mark

: task: ( -- ) create tcb ;

: awake ( up - 0 | up )
   last-woken @
   begin 2dup = if drop exit then
      dup @ last-woken @ <>
   while @
   repeat drop drop 0 ;

: alone ( n up - )
   push ablock * dup allocate throw
   dup r@ tcb>hp + ! dup r@ tcb>hp0 + !      \ HP in lower half
   swap 2/ +
   dup r@ tcb>dp + ! pop tcb>dp0 + ! ;       \ DP in upper half

: wake ( up -- ) dup awake
   if drop exit then
   tcb>actlink + dup
   last-woken @ over !               \ point this task to last-woken
   last-woken @                      \ search for task pointing to last-woken
   begin dup @ last-woken @ <>       \ have we not yet come a full circle?
   while @
   repeat !                          \ point last task to this task
   last-woken ! ;                    \ become last-woken

: sleep ( up - ) dup awake
   if tcb>actlink + dup last-woken @ =  \ are we last-woken?
      if dup @ last-woken !             \ make next task last-woken
      then dup @ swap dup               \ get a.l.f. of next task
      begin dup @ 2 pick <>             \ have we found the last task?
      while @
      repeat nip !                      \ point last task to next task
   exit then drop ;

: stop   ( - ) self sleep pause ;
: kill ( up - ) dup tcb>hp0 + @ free drop sleep ;
: retire ( - ) self kill pause ;

: enthload ( - ) blk @ ['] load catch stop ; hide
: fluxload ( - ) blk @ ['] fload catch stop ; hide

: give ( n up - ) tcb>sp + over cells neg over +! @ swap
        0 ?do tuck ! cell+ loop drop ;
: take ( n up - ) tcb>sp + over cells over +! @ swap
        0 ?do cell- dup @ swap loop drop ;

: update ( a - )
   a@ push a!
   root @ !a+
   macro @ !a+
   flux  @ !a+
   superblock     @ !a+
   pop a! ;

: branch ( - a ) here 4 cells allot update ;

: mcb! ( a - )
   dup @ get-current !
   cell+ dup @ root !
   cell+ dup @ macro !
   cell+ dup @ flux !
   cell+ dup @ dp !
   cell+ dup @ hp !
   cell+ @ mark ! ; hide

: mcb@ ( - nx .. n0 )
   mark @
   hp @
   dp @
   flux @
   macro @
   root @
   get-current @ ; hide

: mcb, ( nx .. n0 - )
   , , , , , , , ; hide

: empty  ( - ) begin mark @ dup while execute repeat drop
   here mcb@ mcb, here swap postpone literal postpone mcb! postpone exit mark ! ;

: marker ( - ) mcb@ create mcb, get-current @ nfa>cfa mark ! does> mcb! ;

: grow ( b u up - ) ['] enthload over
   dup tcb>rp0 + cell- tuck swap tcb>rp + ! !
   tuck tcb>blk  + !     ( b up - )
   dup tcb>mark  + off
   dup tcb>hand  + off
   dup tcb>areg  + off
   dup tcb>dp    + off
   dup tcb>dp0   + off
   dup tcb>hp    + off
   dup tcb>hp0   + off
   dup tcb>state + off
   dup tcb>tib   + off
   dup tcb>#tib  + off
   dup tcb>in    + off
   dup tcb>sid   + off
   dup tcb>hist  + off
   dup tcb>root  + over tcb>current   + !
   1               over tcb>search    + !
   dup tcb>root  + over tcb>swb       + !
   0a              over tcb>base      + !
   a@ push swap a!
   @a+ over tcb>root  + !
   @a+ over tcb>macro + !
   @a+ over tcb>flux  + !
   @a+ over tcb>sblk  + ! pop a!
   focus @    swap tcb>focus + ! ;

: fgrow ( b u up - ) ['] fluxload over
   dup tcb>rp0 + cell- tuck swap tcb>rp + ! !
   tuck tcb>blk  + !     ( b up - )
   dup tcb>mark  + off
   dup tcb>hand  + off
   dup tcb>areg  + off
   dup tcb>dp    + off
   dup tcb>dp0   + off
   dup tcb>hp    + off
   dup tcb>hp0   + off
   dup tcb>state + off
   dup tcb>tib   + off
   dup tcb>#tib  + off
   dup tcb>in    + off
   dup tcb>sid   + off
   dup tcb>hist  + off
   dup tcb>flux  + over tcb>current   + !
   1               over tcb>search    + !
   dup tcb>root  + over tcb>swb       + !
   0a              over tcb>base      + !
   a@ push swap a!
   @a+ over tcb>root  + !
   @a+ over tcb>macro + !
   @a+ over tcb>flux  + !
   @a+ over tcb>sblk  + ! pop a!
   focus @    swap tcb>focus + ! ;

: task! ( xt up -- )
   dup tcb>rp0 + cell- tuck swap tcb>rp + ! ! ;    \ store first retrun address

: .tasks ( - )
   cyan >fg cr ." Active Tasks" last-woken @ gray >fg
   begin dup cell+ @ cr count type @ dup last-woken @ = until drop ;

: ms ( n - ) push 3f8 @ begin pause 3f8 @ over - r@ > until pop 2drop ;

\ ------------- Task Zero ------------------------------------------------------

code INIT ( - )
        pop w
        mov up console #
        mov sp up
        add sp tcb>sp0 #
        mov rp up
        add rp tcb>rp0 #
        jmp w end-code hide

: COLD ( - ) init 20000 superblock ! 1 load abort ; hide

icode cli ( - ) cli ret end-code
icode sti ( - ) sti ret end-code


